module Display (idle, display) where
 
import Graphics.UI.GLUT
import Control.Monad
import Data.IORef
import Cube
import Points
 
display :: IORef GLfloat -> IORef (GLfloat, GLfloat) -> IORef GLfloat -> DisplayCallback
display angle pos zoom = do 
  clear [ColorBuffer, DepthBuffer] -- clear depth buffer, too
  clear [ColorBuffer]
  loadIdentity
  (x',y') <- get pos
  translate $ Vector3 x' y' 0
  preservingMatrix $ do
    a <- get angle
    z <- get zoom
    rotate a $ Vector3 (4) 3 1 -- changed y-component a bit to show off cube corners
    scale z z (z::GLfloat)
    forM_ (pointlevel 4) $ \(x,y,z,m,s,l) -> preservingMatrix $ do
      translate $ Vector3 x y z
      color $ Color3 (((x+2)/4)::GLfloat) ((y+2)/4) ((z+2)/4) -- set outline color to black
      cube s -- draw the outline
      --color $ Color3 ((1)::GLfloat) (1) (1)
      --cubeFrame s
  swapBuffers
 
idle :: IORef GLfloat -> IORef GLfloat -> IdleCallback
idle angle delta = do
  d <- get delta
  angle $~! (+ d)
  postRedisplay Nothing

--    