module Points where
 
import Graphics.Rendering.OpenGL
 
pointsin :: (GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat) -> [(GLfloat,GLfloat,GLfloat,GLfloat, GLfloat,GLfloat)]
pointsin (x, y, z, s, m, l) = [	(e*m+x, r*m+y, t*m+z, m,s,l)
					 			|e<-[-1,0,1],r<-[-1,0,1],t<-[-1,0,1], 
								    (e /= 0 && r /= 0) || (e /= 0 && t /= 0) || (r /= 0 && t /= 0)]

pointlevel :: Int -> [(GLfloat,GLfloat,GLfloat,GLfloat,GLfloat,GLfloat)]
pointlevel x = concat (map pointsin (megarec x))

megarec :: Int -> [(GLfloat,GLfloat,GLfloat,GLfloat,GLfloat,GLfloat)]
megarec 0 = [(0,0,0,1,2,1)]
megarec 1 = callpoints (0,0,0,1,2,1)
megarec x = concat (map callpoints (megarec (x-1)))

cort :: GLfloat -> GLfloat
cort 0 = 0
cort x = 2*(1/(3^(round (x-1))))

callpoints :: (GLfloat, GLfloat, GLfloat, GLfloat,GLfloat,GLfloat) -> [(GLfloat,GLfloat,GLfloat,GLfloat, GLfloat,GLfloat)]
callpoints (i, o, p, s, m, x) = [(((i) + (e * cort x)), 
					 			  ((o) + (r * cort x)),
								  ((p) + (t * cort x)), 
								  (1/3 * s ), -- Quads level
								  (1/3 * m ), -- Quads level
								  (x+1))
								    |e<-[-1,0,1],r<-[-1,0,1],t<-[-1,0,1], 
								    (e /= 0 && r /= 0) || (e /= 0 && t /= 0) || (r /= 0 && t /= 0)]